package com.lightinit.hsdataplatformresdir.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class ResourceExample extends BaseExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public ResourceExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andResourceTypeIsNull() {
            addCriterion("resource_type is null");
            return (Criteria) this;
        }

        public Criteria andResourceTypeIsNotNull() {
            addCriterion("resource_type is not null");
            return (Criteria) this;
        }

        public Criteria andResourceTypeEqualTo(String value) {
            addCriterion("resource_type =", value, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceTypeNotEqualTo(String value) {
            addCriterion("resource_type <>", value, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceTypeGreaterThan(String value) {
            addCriterion("resource_type >", value, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceTypeGreaterThanOrEqualTo(String value) {
            addCriterion("resource_type >=", value, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceTypeLessThan(String value) {
            addCriterion("resource_type <", value, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceTypeLessThanOrEqualTo(String value) {
            addCriterion("resource_type <=", value, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceTypeLike(String value) {
            addCriterion("resource_type like", value, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceTypeNotLike(String value) {
            addCriterion("resource_type not like", value, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceTypeIn(List<String> values) {
            addCriterion("resource_type in", values, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceTypeNotIn(List<String> values) {
            addCriterion("resource_type not in", values, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceTypeBetween(String value1, String value2) {
            addCriterion("resource_type between", value1, value2, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceTypeNotBetween(String value1, String value2) {
            addCriterion("resource_type not between", value1, value2, "resourceType");
            return (Criteria) this;
        }

        public Criteria andResourceStateIsNull() {
            addCriterion("resource_state is null");
            return (Criteria) this;
        }

        public Criteria andResourceStateIsNotNull() {
            addCriterion("resource_state is not null");
            return (Criteria) this;
        }

        public Criteria andResourceStateEqualTo(String value) {
            addCriterion("resource_state =", value, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceStateNotEqualTo(String value) {
            addCriterion("resource_state <>", value, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceStateGreaterThan(String value) {
            addCriterion("resource_state >", value, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceStateGreaterThanOrEqualTo(String value) {
            addCriterion("resource_state >=", value, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceStateLessThan(String value) {
            addCriterion("resource_state <", value, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceStateLessThanOrEqualTo(String value) {
            addCriterion("resource_state <=", value, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceStateLike(String value) {
            addCriterion("resource_state like", value, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceStateNotLike(String value) {
            addCriterion("resource_state not like", value, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceStateIn(List<String> values) {
            addCriterion("resource_state in", values, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceStateNotIn(List<String> values) {
            addCriterion("resource_state not in", values, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceStateBetween(String value1, String value2) {
            addCriterion("resource_state between", value1, value2, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceStateNotBetween(String value1, String value2) {
            addCriterion("resource_state not between", value1, value2, "resourceState");
            return (Criteria) this;
        }

        public Criteria andResourceNameIsNull() {
            addCriterion("resource_name is null");
            return (Criteria) this;
        }

        public Criteria andResourceNameIsNotNull() {
            addCriterion("resource_name is not null");
            return (Criteria) this;
        }

        public Criteria andResourceNameEqualTo(String value) {
            addCriterion("resource_name =", value, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceNameNotEqualTo(String value) {
            addCriterion("resource_name <>", value, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceNameGreaterThan(String value) {
            addCriterion("resource_name >", value, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceNameGreaterThanOrEqualTo(String value) {
            addCriterion("resource_name >=", value, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceNameLessThan(String value) {
            addCriterion("resource_name <", value, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceNameLessThanOrEqualTo(String value) {
            addCriterion("resource_name <=", value, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceNameLike(String value) {
            addCriterion("resource_name like", value, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceNameNotLike(String value) {
            addCriterion("resource_name not like", value, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceNameIn(List<String> values) {
            addCriterion("resource_name in", values, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceNameNotIn(List<String> values) {
            addCriterion("resource_name not in", values, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceNameBetween(String value1, String value2) {
            addCriterion("resource_name between", value1, value2, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceNameNotBetween(String value1, String value2) {
            addCriterion("resource_name not between", value1, value2, "resourceName");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityIsNull() {
            addCriterion("resource_identity is null");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityIsNotNull() {
            addCriterion("resource_identity is not null");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityEqualTo(String value) {
            addCriterion("resource_identity =", value, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityNotEqualTo(String value) {
            addCriterion("resource_identity <>", value, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityGreaterThan(String value) {
            addCriterion("resource_identity >", value, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityGreaterThanOrEqualTo(String value) {
            addCriterion("resource_identity >=", value, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityLessThan(String value) {
            addCriterion("resource_identity <", value, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityLessThanOrEqualTo(String value) {
            addCriterion("resource_identity <=", value, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityLike(String value) {
            addCriterion("resource_identity like", value, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityNotLike(String value) {
            addCriterion("resource_identity not like", value, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityIn(List<String> values) {
            addCriterion("resource_identity in", values, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityNotIn(List<String> values) {
            addCriterion("resource_identity not in", values, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityBetween(String value1, String value2) {
            addCriterion("resource_identity between", value1, value2, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceIdentityNotBetween(String value1, String value2) {
            addCriterion("resource_identity not between", value1, value2, "resourceIdentity");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryIsNull() {
            addCriterion("resource_summary is null");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryIsNotNull() {
            addCriterion("resource_summary is not null");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryEqualTo(String value) {
            addCriterion("resource_summary =", value, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryNotEqualTo(String value) {
            addCriterion("resource_summary <>", value, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryGreaterThan(String value) {
            addCriterion("resource_summary >", value, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryGreaterThanOrEqualTo(String value) {
            addCriterion("resource_summary >=", value, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryLessThan(String value) {
            addCriterion("resource_summary <", value, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryLessThanOrEqualTo(String value) {
            addCriterion("resource_summary <=", value, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryLike(String value) {
            addCriterion("resource_summary like", value, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryNotLike(String value) {
            addCriterion("resource_summary not like", value, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryIn(List<String> values) {
            addCriterion("resource_summary in", values, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryNotIn(List<String> values) {
            addCriterion("resource_summary not in", values, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryBetween(String value1, String value2) {
            addCriterion("resource_summary between", value1, value2, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andResourceSummaryNotBetween(String value1, String value2) {
            addCriterion("resource_summary not between", value1, value2, "resourceSummary");
            return (Criteria) this;
        }

        public Criteria andRegisterDateIsNull() {
            addCriterion("register_date is null");
            return (Criteria) this;
        }

        public Criteria andRegisterDateIsNotNull() {
            addCriterion("register_date is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterDateEqualTo(Date value) {
            addCriterion("register_date =", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateNotEqualTo(Date value) {
            addCriterion("register_date <>", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateGreaterThan(Date value) {
            addCriterion("register_date >", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateGreaterThanOrEqualTo(Date value) {
            addCriterion("register_date >=", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateLessThan(Date value) {
            addCriterion("register_date <", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateLessThanOrEqualTo(Date value) {
            addCriterion("register_date <=", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateIn(List<Date> values) {
            addCriterion("register_date in", values, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateNotIn(List<Date> values) {
            addCriterion("register_date not in", values, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateBetween(Date value1, Date value2) {
            addCriterion("register_date between", value1, value2, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateNotBetween(Date value1, Date value2) {
            addCriterion("register_date not between", value1, value2, "registerDate");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeIsNull() {
            addCriterion("catelog_type is null");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeIsNotNull() {
            addCriterion("catelog_type is not null");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeEqualTo(String value) {
            addCriterion("catelog_type =", value, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeNotEqualTo(String value) {
            addCriterion("catelog_type <>", value, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeGreaterThan(String value) {
            addCriterion("catelog_type >", value, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeGreaterThanOrEqualTo(String value) {
            addCriterion("catelog_type >=", value, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeLessThan(String value) {
            addCriterion("catelog_type <", value, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeLessThanOrEqualTo(String value) {
            addCriterion("catelog_type <=", value, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeLike(String value) {
            addCriterion("catelog_type like", value, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeNotLike(String value) {
            addCriterion("catelog_type not like", value, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeIn(List<String> values) {
            addCriterion("catelog_type in", values, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeNotIn(List<String> values) {
            addCriterion("catelog_type not in", values, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeBetween(String value1, String value2) {
            addCriterion("catelog_type between", value1, value2, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogTypeNotBetween(String value1, String value2) {
            addCriterion("catelog_type not between", value1, value2, "catelogType");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicIsNull() {
            addCriterion("catelog_basic is null");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicIsNotNull() {
            addCriterion("catelog_basic is not null");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicEqualTo(Long value) {
            addCriterion("catelog_basic =", value, "catelogBasic");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicNotEqualTo(Long value) {
            addCriterion("catelog_basic <>", value, "catelogBasic");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicGreaterThan(Long value) {
            addCriterion("catelog_basic >", value, "catelogBasic");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicGreaterThanOrEqualTo(Long value) {
            addCriterion("catelog_basic >=", value, "catelogBasic");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicLessThan(Long value) {
            addCriterion("catelog_basic <", value, "catelogBasic");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicLessThanOrEqualTo(Long value) {
            addCriterion("catelog_basic <=", value, "catelogBasic");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicIn(List<Long> values) {
            addCriterion("catelog_basic in", values, "catelogBasic");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicNotIn(List<Long> values) {
            addCriterion("catelog_basic not in", values, "catelogBasic");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicBetween(Long value1, Long value2) {
            addCriterion("catelog_basic between", value1, value2, "catelogBasic");
            return (Criteria) this;
        }

        public Criteria andCatelogBasicNotBetween(Long value1, Long value2) {
            addCriterion("catelog_basic not between", value1, value2, "catelogBasic");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorIsNull() {
            addCriterion("catelog_sector is null");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorIsNotNull() {
            addCriterion("catelog_sector is not null");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorEqualTo(Long value) {
            addCriterion("catelog_sector =", value, "catelogSector");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorNotEqualTo(Long value) {
            addCriterion("catelog_sector <>", value, "catelogSector");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorGreaterThan(Long value) {
            addCriterion("catelog_sector >", value, "catelogSector");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorGreaterThanOrEqualTo(Long value) {
            addCriterion("catelog_sector >=", value, "catelogSector");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorLessThan(Long value) {
            addCriterion("catelog_sector <", value, "catelogSector");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorLessThanOrEqualTo(Long value) {
            addCriterion("catelog_sector <=", value, "catelogSector");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorIn(List<Long> values) {
            addCriterion("catelog_sector in", values, "catelogSector");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorNotIn(List<Long> values) {
            addCriterion("catelog_sector not in", values, "catelogSector");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorBetween(Long value1, Long value2) {
            addCriterion("catelog_sector between", value1, value2, "catelogSector");
            return (Criteria) this;
        }

        public Criteria andCatelogSectorNotBetween(Long value1, Long value2) {
            addCriterion("catelog_sector not between", value1, value2, "catelogSector");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeIsNull() {
            addCriterion("catelog_theme is null");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeIsNotNull() {
            addCriterion("catelog_theme is not null");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeEqualTo(Long value) {
            addCriterion("catelog_theme =", value, "catelogTheme");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeNotEqualTo(Long value) {
            addCriterion("catelog_theme <>", value, "catelogTheme");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeGreaterThan(Long value) {
            addCriterion("catelog_theme >", value, "catelogTheme");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeGreaterThanOrEqualTo(Long value) {
            addCriterion("catelog_theme >=", value, "catelogTheme");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeLessThan(Long value) {
            addCriterion("catelog_theme <", value, "catelogTheme");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeLessThanOrEqualTo(Long value) {
            addCriterion("catelog_theme <=", value, "catelogTheme");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeIn(List<Long> values) {
            addCriterion("catelog_theme in", values, "catelogTheme");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeNotIn(List<Long> values) {
            addCriterion("catelog_theme not in", values, "catelogTheme");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeBetween(Long value1, Long value2) {
            addCriterion("catelog_theme between", value1, value2, "catelogTheme");
            return (Criteria) this;
        }

        public Criteria andCatelogThemeNotBetween(Long value1, Long value2) {
            addCriterion("catelog_theme not between", value1, value2, "catelogTheme");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomIsNull() {
            addCriterion("catelog_custom is null");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomIsNotNull() {
            addCriterion("catelog_custom is not null");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomEqualTo(Long value) {
            addCriterion("catelog_custom =", value, "catelogCustom");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomNotEqualTo(Long value) {
            addCriterion("catelog_custom <>", value, "catelogCustom");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomGreaterThan(Long value) {
            addCriterion("catelog_custom >", value, "catelogCustom");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomGreaterThanOrEqualTo(Long value) {
            addCriterion("catelog_custom >=", value, "catelogCustom");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomLessThan(Long value) {
            addCriterion("catelog_custom <", value, "catelogCustom");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomLessThanOrEqualTo(Long value) {
            addCriterion("catelog_custom <=", value, "catelogCustom");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomIn(List<Long> values) {
            addCriterion("catelog_custom in", values, "catelogCustom");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomNotIn(List<Long> values) {
            addCriterion("catelog_custom not in", values, "catelogCustom");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomBetween(Long value1, Long value2) {
            addCriterion("catelog_custom between", value1, value2, "catelogCustom");
            return (Criteria) this;
        }

        public Criteria andCatelogCustomNotBetween(Long value1, Long value2) {
            addCriterion("catelog_custom not between", value1, value2, "catelogCustom");
            return (Criteria) this;
        }

        public Criteria andShareTypeIsNull() {
            addCriterion("share_type is null");
            return (Criteria) this;
        }

        public Criteria andShareTypeIsNotNull() {
            addCriterion("share_type is not null");
            return (Criteria) this;
        }

        public Criteria andShareTypeEqualTo(String value) {
            addCriterion("share_type =", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeNotEqualTo(String value) {
            addCriterion("share_type <>", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeGreaterThan(String value) {
            addCriterion("share_type >", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeGreaterThanOrEqualTo(String value) {
            addCriterion("share_type >=", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeLessThan(String value) {
            addCriterion("share_type <", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeLessThanOrEqualTo(String value) {
            addCriterion("share_type <=", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeLike(String value) {
            addCriterion("share_type like", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeNotLike(String value) {
            addCriterion("share_type not like", value, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeIn(List<String> values) {
            addCriterion("share_type in", values, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeNotIn(List<String> values) {
            addCriterion("share_type not in", values, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeBetween(String value1, String value2) {
            addCriterion("share_type between", value1, value2, "shareType");
            return (Criteria) this;
        }

        public Criteria andShareTypeNotBetween(String value1, String value2) {
            addCriterion("share_type not between", value1, value2, "shareType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeIsNull() {
            addCriterion("open_type is null");
            return (Criteria) this;
        }

        public Criteria andOpenTypeIsNotNull() {
            addCriterion("open_type is not null");
            return (Criteria) this;
        }

        public Criteria andOpenTypeEqualTo(String value) {
            addCriterion("open_type =", value, "openType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeNotEqualTo(String value) {
            addCriterion("open_type <>", value, "openType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeGreaterThan(String value) {
            addCriterion("open_type >", value, "openType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeGreaterThanOrEqualTo(String value) {
            addCriterion("open_type >=", value, "openType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeLessThan(String value) {
            addCriterion("open_type <", value, "openType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeLessThanOrEqualTo(String value) {
            addCriterion("open_type <=", value, "openType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeLike(String value) {
            addCriterion("open_type like", value, "openType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeNotLike(String value) {
            addCriterion("open_type not like", value, "openType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeIn(List<String> values) {
            addCriterion("open_type in", values, "openType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeNotIn(List<String> values) {
            addCriterion("open_type not in", values, "openType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeBetween(String value1, String value2) {
            addCriterion("open_type between", value1, value2, "openType");
            return (Criteria) this;
        }

        public Criteria andOpenTypeNotBetween(String value1, String value2) {
            addCriterion("open_type not between", value1, value2, "openType");
            return (Criteria) this;
        }

        public Criteria andAllowDealIsNull() {
            addCriterion("allow_deal is null");
            return (Criteria) this;
        }

        public Criteria andAllowDealIsNotNull() {
            addCriterion("allow_deal is not null");
            return (Criteria) this;
        }

        public Criteria andAllowDealEqualTo(Byte value) {
            addCriterion("allow_deal =", value, "allowDeal");
            return (Criteria) this;
        }

        public Criteria andAllowDealNotEqualTo(Byte value) {
            addCriterion("allow_deal <>", value, "allowDeal");
            return (Criteria) this;
        }

        public Criteria andAllowDealGreaterThan(Byte value) {
            addCriterion("allow_deal >", value, "allowDeal");
            return (Criteria) this;
        }

        public Criteria andAllowDealGreaterThanOrEqualTo(Byte value) {
            addCriterion("allow_deal >=", value, "allowDeal");
            return (Criteria) this;
        }

        public Criteria andAllowDealLessThan(Byte value) {
            addCriterion("allow_deal <", value, "allowDeal");
            return (Criteria) this;
        }

        public Criteria andAllowDealLessThanOrEqualTo(Byte value) {
            addCriterion("allow_deal <=", value, "allowDeal");
            return (Criteria) this;
        }

        public Criteria andAllowDealIn(List<Byte> values) {
            addCriterion("allow_deal in", values, "allowDeal");
            return (Criteria) this;
        }

        public Criteria andAllowDealNotIn(List<Byte> values) {
            addCriterion("allow_deal not in", values, "allowDeal");
            return (Criteria) this;
        }

        public Criteria andAllowDealBetween(Byte value1, Byte value2) {
            addCriterion("allow_deal between", value1, value2, "allowDeal");
            return (Criteria) this;
        }

        public Criteria andAllowDealNotBetween(Byte value1, Byte value2) {
            addCriterion("allow_deal not between", value1, value2, "allowDeal");
            return (Criteria) this;
        }

        public Criteria andAuditedByIsNull() {
            addCriterion("audited_by is null");
            return (Criteria) this;
        }

        public Criteria andAuditedByIsNotNull() {
            addCriterion("audited_by is not null");
            return (Criteria) this;
        }

        public Criteria andAuditedByEqualTo(Long value) {
            addCriterion("audited_by =", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotEqualTo(Long value) {
            addCriterion("audited_by <>", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByGreaterThan(Long value) {
            addCriterion("audited_by >", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByGreaterThanOrEqualTo(Long value) {
            addCriterion("audited_by >=", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByLessThan(Long value) {
            addCriterion("audited_by <", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByLessThanOrEqualTo(Long value) {
            addCriterion("audited_by <=", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByIn(List<Long> values) {
            addCriterion("audited_by in", values, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotIn(List<Long> values) {
            addCriterion("audited_by not in", values, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByBetween(Long value1, Long value2) {
            addCriterion("audited_by between", value1, value2, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotBetween(Long value1, Long value2) {
            addCriterion("audited_by not between", value1, value2, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIsNull() {
            addCriterion("audited_at is null");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIsNotNull() {
            addCriterion("audited_at is not null");
            return (Criteria) this;
        }

        public Criteria andAuditedAtEqualTo(Date value) {
            addCriterion("audited_at =", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotEqualTo(Date value) {
            addCriterion("audited_at <>", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtGreaterThan(Date value) {
            addCriterion("audited_at >", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("audited_at >=", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtLessThan(Date value) {
            addCriterion("audited_at <", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtLessThanOrEqualTo(Date value) {
            addCriterion("audited_at <=", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIn(List<Date> values) {
            addCriterion("audited_at in", values, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotIn(List<Date> values) {
            addCriterion("audited_at not in", values, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtBetween(Date value1, Date value2) {
            addCriterion("audited_at between", value1, value2, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotBetween(Date value1, Date value2) {
            addCriterion("audited_at not between", value1, value2, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditResultIsNull() {
            addCriterion("audit_result is null");
            return (Criteria) this;
        }

        public Criteria andAuditResultIsNotNull() {
            addCriterion("audit_result is not null");
            return (Criteria) this;
        }

        public Criteria andAuditResultEqualTo(String value) {
            addCriterion("audit_result =", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotEqualTo(String value) {
            addCriterion("audit_result <>", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultGreaterThan(String value) {
            addCriterion("audit_result >", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultGreaterThanOrEqualTo(String value) {
            addCriterion("audit_result >=", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLessThan(String value) {
            addCriterion("audit_result <", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLessThanOrEqualTo(String value) {
            addCriterion("audit_result <=", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLike(String value) {
            addCriterion("audit_result like", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotLike(String value) {
            addCriterion("audit_result not like", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultIn(List<String> values) {
            addCriterion("audit_result in", values, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotIn(List<String> values) {
            addCriterion("audit_result not in", values, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultBetween(String value1, String value2) {
            addCriterion("audit_result between", value1, value2, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotBetween(String value1, String value2) {
            addCriterion("audit_result not between", value1, value2, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIsNull() {
            addCriterion("audit_opinion is null");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIsNotNull() {
            addCriterion("audit_opinion is not null");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionEqualTo(String value) {
            addCriterion("audit_opinion =", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotEqualTo(String value) {
            addCriterion("audit_opinion <>", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionGreaterThan(String value) {
            addCriterion("audit_opinion >", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionGreaterThanOrEqualTo(String value) {
            addCriterion("audit_opinion >=", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLessThan(String value) {
            addCriterion("audit_opinion <", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLessThanOrEqualTo(String value) {
            addCriterion("audit_opinion <=", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLike(String value) {
            addCriterion("audit_opinion like", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotLike(String value) {
            addCriterion("audit_opinion not like", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIn(List<String> values) {
            addCriterion("audit_opinion in", values, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotIn(List<String> values) {
            addCriterion("audit_opinion not in", values, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionBetween(String value1, String value2) {
            addCriterion("audit_opinion between", value1, value2, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotBetween(String value1, String value2) {
            addCriterion("audit_opinion not between", value1, value2, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(Long value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(Long value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(Long value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(Long value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(Long value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(Long value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<Long> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<Long> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(Long value1, Long value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(Long value1, Long value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(Long value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(Long value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(Long value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(Long value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(Long value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(Long value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<Long> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<Long> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(Long value1, Long value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(Long value1, Long value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andOutId1IsNull() {
            addCriterion("out_id_1 is null");
            return (Criteria) this;
        }

        public Criteria andOutId1IsNotNull() {
            addCriterion("out_id_1 is not null");
            return (Criteria) this;
        }

        public Criteria andOutId1EqualTo(String value) {
            addCriterion("out_id_1 =", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1NotEqualTo(String value) {
            addCriterion("out_id_1 <>", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1GreaterThan(String value) {
            addCriterion("out_id_1 >", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1GreaterThanOrEqualTo(String value) {
            addCriterion("out_id_1 >=", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1LessThan(String value) {
            addCriterion("out_id_1 <", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1LessThanOrEqualTo(String value) {
            addCriterion("out_id_1 <=", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1Like(String value) {
            addCriterion("out_id_1 like", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1NotLike(String value) {
            addCriterion("out_id_1 not like", value, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1In(List<String> values) {
            addCriterion("out_id_1 in", values, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1NotIn(List<String> values) {
            addCriterion("out_id_1 not in", values, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1Between(String value1, String value2) {
            addCriterion("out_id_1 between", value1, value2, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId1NotBetween(String value1, String value2) {
            addCriterion("out_id_1 not between", value1, value2, "outId1");
            return (Criteria) this;
        }

        public Criteria andOutId2IsNull() {
            addCriterion("out_id_2 is null");
            return (Criteria) this;
        }

        public Criteria andOutId2IsNotNull() {
            addCriterion("out_id_2 is not null");
            return (Criteria) this;
        }

        public Criteria andOutId2EqualTo(String value) {
            addCriterion("out_id_2 =", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2NotEqualTo(String value) {
            addCriterion("out_id_2 <>", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2GreaterThan(String value) {
            addCriterion("out_id_2 >", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2GreaterThanOrEqualTo(String value) {
            addCriterion("out_id_2 >=", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2LessThan(String value) {
            addCriterion("out_id_2 <", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2LessThanOrEqualTo(String value) {
            addCriterion("out_id_2 <=", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2Like(String value) {
            addCriterion("out_id_2 like", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2NotLike(String value) {
            addCriterion("out_id_2 not like", value, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2In(List<String> values) {
            addCriterion("out_id_2 in", values, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2NotIn(List<String> values) {
            addCriterion("out_id_2 not in", values, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2Between(String value1, String value2) {
            addCriterion("out_id_2 between", value1, value2, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId2NotBetween(String value1, String value2) {
            addCriterion("out_id_2 not between", value1, value2, "outId2");
            return (Criteria) this;
        }

        public Criteria andOutId3IsNull() {
            addCriterion("out_id_3 is null");
            return (Criteria) this;
        }

        public Criteria andOutId3IsNotNull() {
            addCriterion("out_id_3 is not null");
            return (Criteria) this;
        }

        public Criteria andOutId3EqualTo(String value) {
            addCriterion("out_id_3 =", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3NotEqualTo(String value) {
            addCriterion("out_id_3 <>", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3GreaterThan(String value) {
            addCriterion("out_id_3 >", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3GreaterThanOrEqualTo(String value) {
            addCriterion("out_id_3 >=", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3LessThan(String value) {
            addCriterion("out_id_3 <", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3LessThanOrEqualTo(String value) {
            addCriterion("out_id_3 <=", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3Like(String value) {
            addCriterion("out_id_3 like", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3NotLike(String value) {
            addCriterion("out_id_3 not like", value, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3In(List<String> values) {
            addCriterion("out_id_3 in", values, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3NotIn(List<String> values) {
            addCriterion("out_id_3 not in", values, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3Between(String value1, String value2) {
            addCriterion("out_id_3 between", value1, value2, "outId3");
            return (Criteria) this;
        }

        public Criteria andOutId3NotBetween(String value1, String value2) {
            addCriterion("out_id_3 not between", value1, value2, "outId3");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}